/* ds_i2c.c ---
*
* Filename: ds_i2c.c
* Description:
* Author:
* Maintainer:
* Created: Fri Jan 25 08:34:50 2013
* Last-Updated:
* By:
* Update #: 0
* Keywords:
* Compatibility:
*
*/

/* Commentary:
*
*
*
*/

/* Change log:
*
*
*/

/* Code: */
#include <ds_i2c.h>  // Pull in include files for F30x standard drivers 

void ds_i2c1_init(void){
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_I2C1,ENABLE); 
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);

	/* SCL and SDA */
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_DOWN;
	GPIO_Init(GPIOB,&GPIO_InitStructure);

	GPIO_PinAFConfig(GPIOB,6,GPIO_AF_4);
	GPIO_PinAFConfig(GPIOB,7,GPIO_AF_4);

	/* SCL and SDA */
	I2C_InitTypeDef I2C_InitStructure;
	I2C_InitStructure.I2C_Mode = I2C_Mode_I2C;
	I2C_InitStructure.I2C_AnalogFilter = I2C_AnalogFilter_Enable;
	I2C_InitStructure.I2C_DigitalFilter = 0x00;
	I2C_InitStructure.I2C_OwnAddress1 = 0x00;
	I2C_InitStructure.I2C_Ack = I2C_Ack_Enable;
	I2C_InitStructure.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
	I2C_InitStructure.I2C_Timing = 0x00902025;
	I2C_Init(I2C1, &I2C_InitStructure);
	I2C_Cmd(I2C1, ENABLE);
}
void ds_i2c1_read(uint8_t device, uint8_t reg, uint8_t* buffer, uint16_t numbytes){
	//Wait for the I2C device to become available
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET);
	//Send start bit and device.
	I2C_TransferHandling(I2C1, device, 1, I2C_SoftEnd_Mode, I2C_Generate_Start_Write);
	//Wait for the transmitter to become empty.
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET);
	//If the read transfer is going to involve more than one byte, then set the multiple bit in the register address.
	if (numbytes>1) {
	  reg |=0x80;                                                                             
	}
	//Send reg and wait for the transfer to complete.	
	I2C_SendData(I2C1,reg);                    
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_TC) == RESET);

	I2C_TransferHandling(I2C1, device, numbytes, I2C_AutoEnd_Mode, I2C_Generate_Start_Read);
	while (numbytes--) {
		while(I2C_GetFlagStatus(I2C1, I2C_ISR_RXNE) == RESET);
		*buffer++ = I2C_ReceiveData(I2C1);
	}
	//Poll for the stop bit. 
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET); 
	I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);
}

void ds_i2c1_write(uint8_t device, uint8_t reg, uint8_t* value){
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_BUSY) != RESET);

	I2C_TransferHandling(I2C1, device, 1, I2C_Reload_Mode, I2C_Generate_Start_Write);
	while (I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET);

	I2C_SendData(I2C1,reg);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TCR) == RESET);

	I2C_TransferHandling(I2C1, device, 1, I2C_AutoEnd_Mode, I2C_No_StartStop);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_TXIS) == RESET);

	I2C_SendData(I2C1, *value);
	while(I2C_GetFlagStatus(I2C1, I2C_ISR_STOPF) == RESET);
I2C_ClearFlag(I2C1, I2C_ICR_STOPCF);
}

/* ds_i2c.c ends here */
