/* led.c --- 
 * 
 * Filename: led.c
 * Description: 
 * Author: 
 * Maintainer: 
 * Created: Thu Jan 10 10:53:06 2013
 * Last-Updated: 
 *           By: 
 *     Update #: 0
 * Keywords: 
 * Compatibility: 
 * 
 */

/* Commentary: 
 * 
 * 
 * 
 */

/* Change log:
 * 
 * 
 */

/* Code: */
#include <stm32f30x.h>
#include <ds_led.h>

void ds_led_init(void) {
	// initialize the port and pins for the 8 leds
	//First. Initialize Clocks
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOE, ENABLE);
	//Second, Populate the InitStructure
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15; 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	//Then Initialize Inist Structure
	GPIO_Init(GPIOE, &GPIO_InitStructure);
}

void ds_led_on(int led) {
  // enable the led specified by led parameter
  // led = 0-7 representing the 8 leds
	switch(led){
		case 8: GPIOE->BSRR = GPIO_Pin_8; break;
		case 9: GPIOE->BSRR = GPIO_Pin_9; break;
		case 10: GPIOE->BSRR = GPIO_Pin_10; break;
		case 11: GPIOE->BSRR = GPIO_Pin_11; break;
		case 12: GPIOE->BSRR = GPIO_Pin_12; break;
		case 13: GPIOE->BSRR = GPIO_Pin_13; break;
		case 14: GPIOE->BSRR = GPIO_Pin_14; break;
		case 15: GPIOE->BSRR = GPIO_Pin_15; break;
	}
}
 
void ds_led_off(int led) {
  // disable the led specified by led parameter
  // led = 0-7 representing the 8 leds
	switch(led){
		case 8: GPIOE->BRR = GPIO_Pin_8; break;
		case 9: GPIOE->BRR = GPIO_Pin_9; break;
		case 10: GPIOE->BRR = GPIO_Pin_10; break;
		case 11: GPIOE->BRR = GPIO_Pin_11; break;
		case 12: GPIOE->BRR = GPIO_Pin_12; break;
		case 13: GPIOE->BRR = GPIO_Pin_13; break;
		case 14: GPIOE->BRR = GPIO_Pin_14; break;
		case 15: GPIOE->BRR = GPIO_Pin_15; break;
	}
} 

void ds_led_all_on(void) {
  // turn on all 8 leds 
	int i=0;
	for(i=8;i<16;i++){
		ds_led_on(i);
	}
	//GPIOE->BSRR = 0X8800;
} 

void ds_led_all_off(void) {
  // turn off all 8 leds
	int i=0;
	for(i=8;i<16;i++){
		ds_led_off(i);
	}
	//GPIOE->BRR = 0XFF00;
} 

/* led.c ends here */

